Subject: bug#59691: 29.0.60; typescript-ts-mode: any HTML-like elements causes fontification to become invalid and remaining parse-tree to become jsx-expression

From: Yuan Fu <[email-masked]>
Date: Wed, 30 Nov 2022 02:22:06 -0800

Theodor Thornhill <[email-masked]> writes:

> On 29 November 2022 22:37:25 CET, "Jostein Kjønigsen" <[email-masked]> wrote:
>>Nice!
>>
>>Should we until further notice assume that js-ts-mode suffers from
>> the same issues, and that a jsx-ts-mode might be needed too? To me
>> it at least sounds plausible.
>
> No, because there are no ambiguities in the grammar with types and jsx.
>
>>
>>Speaking of duplication… Now that we have tree-sitter wouldn’t it be
>> possible to use the same parser and/or the same major-modes for
>> JS/JSX as we already do for TS/TSX? JS/JSX is just Typescript
>> without the type-annotations, right?
>>
>>Or are there good reasons for having separate modes for these?
>>
>
> Not sure. I like that a mode maps to a tree-sitter grammar, and personally I don't want to intertwine things to early.

No strong opinions here, but currently a user could install
tree-sitter-js, and find and enable js-ts-mode, which is
straightforward, which is good. Since these four modes doesn’t require
too much boilerplate, I think it’s pretty good right now.

Yuan